def readDictionary(filename):
	# apro il file in sola lettura:
	f = open(filename, "r")

	# riempio un dizionario con parola e sua forma abbreviata
	dizionario = dict()
	#
	# la readline() legge il contenuto di un file una linea alla volta. 
	# Lascia il carattere di newline alla fine, pertanto dovro` toglierlo
	# a mano quando popolo il dizionario
	#
	linea = f.readline()
		
	while linea != '':
		parti = linea.split(' ')
		if len(parti) == 2:
			dizionario[parti[0]] = parti[1].replace("\n", "")
		linea = f.readline()
	# quando ho finito, chiudo il file
	f.close()

	return dizionario

def writeCompressedSMS(testo_compresso, nomefile_out):
	f = open(nomefile_out, "w")
	f.write(testo_compresso)
	f.close() # non dimenticare!


	
def compress(sms_filename, dictionary_filename, sms_compressed_out):
	# leggo il testo dell'SMS originale
	fin = open(sms_filename, "r")
	testo = fin.read()

	# chiudo il file!
	fin.close()
	
	lunghezza_testo_originale = len(testo)
	
	dizionario = readDictionary(dictionary_filename)

	for parola in dizionario.keys():
		testo = testo.replace(parola, dizionario[parola])

	testo_compresso = testo

	# scrivi l'SMS compresso sul file di uscita sms_compressed_out
	writeCompressedSMS(testo_compresso, sms_compressed_out)
	
	# restituisco il fattore di compressione ottenuto sul testo con il dizionario dato, in percentuale.
 	#
	return 100 * (lunghezza_testo_originale - len(testo_compresso)) / lunghezza_testo_originale

	
